#include <qmainwindow.h>
#include <qmessagebox.h>
#include <qframe.h> 

#include <qlayout.h>

#include "help.h"
#include "maindialogimpl.h"

class LCDbinWindow : public QMainWindow
{
	Q_OBJECT
public:
	LCDbinWindow( QWidget* parent = 0, const char* name = 0, WFlags f = WType_TopLevel );

public slots:
	void newDocument();
	void menuHelp();
	void menuAboutMe();
	void menuAboutQt();
	void clipboardChanged();

private slots:
	 // styles
	 void stylePlatinum();
    void styleWindows();
    void styleCDE();
    void styleMotif();
    void styleMotifPlus();
	 
	 // options
	 void optionMenuRow63();
	 void optionMenuRow127();
	 void optionMenuLCD122();
	 void optionMenuLCD128();

private:
	maindialogImpl *mainDialog;
	QTabWidget *tabwidget;
	HelpLCD *help;		// fenetre pour menu d'aide

	// Menu
	QPopupMenu* file;
	QPopupMenu* about;
	QPopupMenu* theme;
	QPopupMenu* edit;
	QPopupMenu* option;
	QMenuBar *menubar;
	// id Menus
	int mSaveBmp, mSaveBin;
	int sMotif, sMotifPlus, sCDE, sPlatinum, sWindows;
	int oLCD122, oLCD128, oRow63, oRow127;


	// barre d'etat
	QStatusBar* statusbar; 

	// Styles
	QFont appFont;

	QClipboard *clipboard;
	QLabel *lblClip;
	QTextView *txtClip;
	// Styles
	void selectStyleMenu(int s);

};

